/* TSP Dynamic Programming */
#include <stdio.h>
int c[10][10], n, source;
int g(int i, int s[], int m)
{
	int q,r,ts[10],small,value,j,k;
	if ( m == 0 ) return c[i][source];
	small = 9999;
	for ( k = 1; k <= m; k++ )
	{
		j = s[k];
		r = 1;
		for (q = 1; q <= m; q++)
			if ( j != s[q] ) ts[r++] = s[q];
		value = c[i][j] + g(j,ts,r-1);
		if ( value < small ) small = value;
	}
	return small;
}
int tsp()
{
	int small, k, i, j, s[10],value;
	small = 9999;
	for ( k = 1; k <= n; k++ )
	{
		if ( k != source )
		{
			for ( i = j = 1; j <= n; j++ )
				if ( j != source && j != k ) s[i++] = j;
			value = c[source][k] + g(k,s,i-1);
			if ( value < small ) small = value;
		}
	}
	return small;
}
void main()
{
	int i,j;
	clrscr();
	printf("Enter the total number of cities\n");
	scanf("%d",&n);
	printf("Enter the cost matrix\n");
	for ( i = 1; i <= n; i++)
		for ( j = 1; j <= n; j++)
			scanf("%d",&c[i][j]);
	printf("Enter the source\n");
	scanf("%d",&source);
	printf("The sohrtest distance = %d\n",tsp());
	getch();
}